<?php

global $user, $template, $lang, $conf, $page;

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

include_once(NBC_NEWS_PATH.'include/constants.php');
include_once(NBC_NEWS_PATH.'include/functions_news.inc.php');
include(get_language_filepath('plugin.lang.php', NBC_NEWS_PATH));
  


// Gestion des onglets
include_once(PHPWG_ROOT_PATH . 'admin/include/functions_tabsheet.inc.php');

$page['tab'] = 'NewsAdmin';

$page_news_admin = get_admin_plugin_menu_link(dirname(__FILE__).'/news_admin.php');

$page['tabsheet'] = array(
    'NewsAdmin' => array('caption' => l10n('title_admin_news'), 'url' => add_url_params($page_news_admin, array('tab' => 'NewsAdmin'))),
    'Users' => array('caption' => l10n('title_users'), 'url' => add_url_params($page_news_admin, array('tab' => 'Users'))),
    'Groups' => array('caption' => l10n('title_groups'), 'url' => add_url_params($page_news_admin, array('tab' => 'Groups'))),
    'Config' => array('caption' => l10n('config'), 'url' => add_url_params($page_news_admin, array('tab' => 'Config'))),
    );

$page['tabsheet'][$page['tab']]['selected'] = true;
template_assign_tabsheet();



// +-----------------------------------------------------------------------+
// |                       variable initialization                         |
// +-----------------------------------------------------------------------+

// if the news is not correct (not numeric, not private)
if (isset($_GET['new_id']) and is_numeric($_GET['new_id']))
{
  $query = '
SELECT status
  FROM '.NEWS_TABLE.' as n
  WHERE n.id = '.$_GET['new_id'].'
;';
  list($status) = mysql_fetch_array(pwg_query($query));
  
  if ('private' == $status)
  {
    $page['new_id'] = $_GET['new_id'];
  }
}

if (!isset($page['new_id']))
{
  $query = '
SELECT id
  FROM '.NEWS_TABLE.'
  WHERE status = \'private\'
  LIMIT 0,1
;';

  list($page['new_id']) = mysql_fetch_array(pwg_query($query));
}

// +-----------------------------------------------------------------------+
// |                           form submission                             |
// +-----------------------------------------------------------------------+

if (isset($_POST) and false)
{
  echo '<pre>';
  print_r($_POST);
  echo '</pre>';
}

if (isset($_POST['deny_granted_groups_submit'])
         and isset($_POST['deny_groups'])
         and count($_POST['deny_groups']) > 0)
{
  // if you forbid access to a news
  $query = '
DELETE
  FROM '.NEWS_GROUP_ACCESS_TABLE.'
  WHERE group_id IN ('.implode(',', $_POST['deny_groups']).')
    AND new_id = '.$page['new_id'].'
;';
  pwg_query($query);
}
else if (isset($_POST['deny_refused_groups_submit'])
         and isset($_POST['refuse_groups'])
         and count($_POST['refuse_groups']) > 0)
{
  // if you forbid access to a news
  $query = '
DELETE
  FROM '.NEWS_GROUP_REFUSED_TABLE.'
  WHERE group_id IN ('.implode(',', $_POST['refuse_groups']).')
    AND new_id = '.$page['new_id'].'
;';
  pwg_query($query);
}
else if (isset($_POST['grant_groups_submit'])
         and isset($_POST['grant_groups'])
         and count($_POST['grant_groups']) > 0)
{
  $inserts = array();
  
  foreach ($_POST['grant_groups'] as $group_id)
  {
    array_push($inserts, array('group_id' => $group_id,
                               'new_id' => $page['new_id']));
  }

  mass_inserts(NEWS_GROUP_ACCESS_TABLE, array('group_id','new_id'), $inserts);
}
else if (isset($_POST['refuse_groups_submit'])
         and isset($_POST['grant_groups'])
         and count($_POST['grant_groups']) > 0)
{
  $inserts = array();
  
  foreach ($_POST['grant_groups'] as $group_id)
  {
    array_push($inserts, array('group_id' => $group_id,
                               'new_id' => $page['new_id']));
  }

  mass_inserts(NEWS_GROUP_REFUSED_TABLE, array('group_id','new_id'), $inserts);
}
else if (isset($_POST['deny_granted_users_submit'])
         and isset($_POST['deny_users'])
         and count($_POST['deny_users']) > 0)
{
  // if you forbid access to a news
  $query = '
DELETE
  FROM '.NEWS_USER_ACCESS_TABLE.'
  WHERE user_id IN ('.implode(',', $_POST['deny_users']).')
    AND new_id = '.$page['new_id'].'
;';
  pwg_query($query);
}
else if (isset($_POST['deny_refused_users_submit'])
         and isset($_POST['refuse_users'])
         and count($_POST['refuse_users']) > 0)
{
  // if you forbid access to a news
  $query = '
DELETE
  FROM '.NEWS_USER_REFUSED_TABLE.'
  WHERE user_id IN ('.implode(',', $_POST['refuse_users']).')
    AND new_id = '.$page['new_id'].'
;';
  pwg_query($query);
}
else if (isset($_POST['grant_users_submit'])
         and isset($_POST['grant_users'])
         and count($_POST['grant_users']) > 0)
{
  $inserts = array();
  
  foreach ($_POST['grant_users'] as $user_id)
  {
    array_push($inserts, array('user_id' => $user_id,
                               'new_id' => $page['new_id']));
  }

  mass_inserts(NEWS_USER_ACCESS_TABLE, array('user_id','new_id'), $inserts);
}
else if (isset($_POST['refuse_users_submit'])
         and isset($_POST['grant_users'])
         and count($_POST['grant_users']) > 0)
{
  $inserts = array();
  
  foreach ($_POST['grant_users'] as $user_id)
  {
    array_push($inserts, array('user_id' => $user_id,
                               'new_id' => $page['new_id']));
  }

  mass_inserts(NEWS_USER_REFUSED_TABLE, array('user_id','new_id'), $inserts);
}
else if (isset($_POST['refuse_indirect_users_submit'])
         and isset($_POST['grant_indirect_users'])
         and count($_POST['grant_indirect_users']) > 0)
{
  $inserts = array();
  
  foreach ($_POST['grant_indirect_users'] as $user_id)
  {
    array_push($inserts, array('user_id' => $user_id,
                               'new_id' => $page['new_id']));
  }

  mass_inserts(NEWS_USER_REFUSED_TABLE, array('user_id','new_id'), $inserts);
}

// +-----------------------------------------------------------------------+
// |                       template initialization                         |
// +-----------------------------------------------------------------------+

$template->set_filenames(array('news_perm' => NBC_NEWS_PATH . 'template/admin/news_perm.tpl'));

  $query = '
SELECT nt.title
  FROM '.NEWS_TRANSLATION_TABLE.' as nt
  INNER JOIN '.NEWS_TABLE.' as n ON n.id = nt.new_id
  WHERE nt.new_id = '.$page['new_id'].'
  AND nt.language = \''.$user['language'].'\'
;';
  $result = pwg_query($query);

$row = mysql_fetch_array($result);

$template->assign_vars(
  array(
    'NEWS_NAV' => '[ '.$page['new_id'].'] - '.$row['title'],
    'U_HELP' => PHPWG_ROOT_PATH.'popuphelp.php?page=news_perm',
    'F_ACTION' => add_url_params(get_admin_plugin_menu_link(dirname(__FILE__).'/news_perm.php'), array('new_id' => $page['new_id'])),
    )
  );

// +-----------------------------------------------------------------------+
// |                          form construction                            |
// +-----------------------------------------------------------------------+

// groups denied are the groups not granted. So we need to find all groups
// minus groups granted to find groups denied.

$groups = array();

// -- Modif Nicco pour ordonner par name
$query = '
SELECT id, name
  FROM '.GROUPS_TABLE.'
  ORDER BY name
;';
// -- Modif Nicco pour ordonner par name
$result = pwg_query($query);

while ($row = mysql_fetch_array($result))
{
  $groups[$row['id']] = $row['name'];
}

// -- Modif Nicco pour ordonner par name
$query = '
SELECT ngdt.group_id, gt.name
  FROM '.NEWS_GROUP_REFUSED_TABLE.' as ngdt, '.GROUPS_TABLE.' as gt
  WHERE ngdt.new_id = '.$page['new_id'].'
  AND ngdt.group_id = gt.id
  ORDER BY gt.name
;';
// -- Modif Nicco pour ordonner par name

$group_refused_ids = array_from_query($query, 'group_id');

// groups refused to access the category
foreach ($group_refused_ids as $group_id)
{
  $template->assign_block_vars(
    'group_refused',
    array(
      'NAME'=>$groups[$group_id],
      'ID'=>$group_id
      )
    );
}

// -- Modif Nicco pour ordonner par name
$query = '
SELECT ngat.group_id, gt.name
  FROM '.NEWS_GROUP_ACCESS_TABLE.' as ngat, '.GROUPS_TABLE.' as gt
  WHERE ngat.new_id = '.$page['new_id'].'
  AND ngat.group_id = gt.id
  ORDER BY gt.name
;';
// -- Modif Nicco pour ordonner par name

$group_granted_ids = array_from_query($query, 'group_id');

// groups granted to access the news
foreach ($group_granted_ids as $group_id)
{
  $template->assign_block_vars(
    'group_granted',
    array(
      'NAME'=>$groups[$group_id],
      'ID'=>$group_id
      )
    );
}

// groups denied
foreach (array_diff(array_keys($groups), array_merge($group_granted_ids, $group_refused_ids)) as $group_id)
{
  $template->assign_block_vars(
    'group_denied',
    array(
      'NAME'=>$groups[$group_id],
      'ID'=>$group_id
      )
    );
}

// users...
$users = array();

$query = '
SELECT '.$conf['user_fields']['id'].' AS id,
       '.$conf['user_fields']['username'].' AS username
  FROM '.USERS_TABLE.'
  ORDER BY username
;';
$result = pwg_query($query);
while($row = mysql_fetch_array($result))
{
  $users[$row['id']] = $row['username'];
}


$query = '
SELECT nud.user_id, u.username
  FROM '.NEWS_USER_REFUSED_TABLE.' as nud, '.USERS_TABLE.' as u
  WHERE new_id = '.$page['new_id'].'
  AND nud.user_id = u.id
  ORDER BY u.username
;';

$user_refused_direct_ids = array_from_query($query, 'user_id');

foreach ($user_refused_direct_ids as $user_id)
{
  $template->assign_block_vars(
    'user_refused',
    array(
      'NAME'=>$users[$user_id],
      'ID'=>$user_id
      )
    );
}

$user_refused_indirect_ids = array();
if (count($group_refused_ids) > 0)
{
  $refused_groups = array();

  $query = '
SELECT ug.user_id, ug.group_id, u.username
  FROM '.USER_GROUP_TABLE.' as ug, '.USERS_TABLE.' as u
  WHERE group_id IN ('.implode(',', $group_refused_ids).')
  AND ug.user_id = u.id
  ORDER BY u.username 
';
  $result = pwg_query($query);
  while ($row = mysql_fetch_array($result))
  {
    if (!isset($refused_groups[$row['group_id']]))
    {
      $refused_groups[$row['group_id']] = array();
    }
    array_push($refused_groups[$row['group_id']], $row['user_id']);
  }

  $user_refused_by_group_ids = array();

  foreach ($refused_groups as $group_users)
  {
    $user_refused_by_group_ids = array_merge($user_refused_by_group_ids,
                                             $group_users);
  }
  $user_refused_by_group_ids = array_unique($user_refused_by_group_ids);
 
 
  $user_refused_indirect_ids = array_diff($user_refused_by_group_ids,
                                          $user_refused_direct_ids);

  foreach ($user_refused_indirect_ids as $user_id)
  {
    $group = '';
   
    foreach ($refused_groups as $group_id => $group_users)
    {
      if (in_array($user_id, $group_users))
      {
        $group = $groups[$group_id];
        break;
      }
    }

    $template->assign_block_vars(
      'user_refused_indirect',
      array(
        'NAME'=>$users[$user_id],
        'GROUP'=>$group
        )
      );
  }
}



$query = '
SELECT nuat.user_id, ut.username
  FROM '.NEWS_USER_ACCESS_TABLE.' as nuat, '.USERS_TABLE.' as ut
  WHERE new_id = '.$page['new_id'].'
  AND nuat.user_id = ut.id
  ORDER BY ut.username
;';
$user_granted_direct_ids = array_diff(array_from_query($query, 'user_id'), $user_refused_indirect_ids, $user_refused_direct_ids);

foreach ($user_granted_direct_ids as $user_id)
{
  $template->assign_block_vars(
    'user_granted',
    array(
      'NAME'=>$users[$user_id],
      'ID'=>$user_id
      )
    );
}

$user_granted_indirect_ids = array();
if (count($group_granted_ids) > 0)
{
  $granted_groups = array();

  $query = '
SELECT ugt.user_id, ugt.group_id, ut.username
  FROM '.USER_GROUP_TABLE.' as ugt, '.USERS_TABLE.' as ut
  WHERE group_id IN ('.implode(',', $group_granted_ids).')
  AND ugt.user_id = ut.id
  ORDER BY ut.username 
';
  $result = pwg_query($query);
  while ($row = mysql_fetch_array($result))
  {
    if (!isset($granted_groups[$row['group_id']]) or isset($refused_groups[$row['group_id']]))
    {
      $granted_groups[$row['group_id']] = array();
    }
    array_push($granted_groups[$row['group_id']], $row['user_id']);
  }

  $user_granted_by_group_ids = array();

  foreach ($granted_groups as $group_users)
  {
    $user_granted_by_group_ids = array_merge($user_granted_by_group_ids,
                                             $group_users);
  }
  $user_granted_by_group_ids = array_unique($user_granted_by_group_ids);
 
 
  $user_granted_indirect_ids = array_diff($user_granted_by_group_ids,
                                          $user_granted_direct_ids,
                                          $user_refused_indirect_ids,
                                          $user_refused_direct_ids);

  foreach ($user_granted_indirect_ids as $user_id)
  {
    $group = '';
   
    foreach ($granted_groups as $group_id => $group_users)
    {
      if (in_array($user_id, $group_users))
      {
        $group = $groups[$group_id];
        break;
      }
    }

    $template->assign_block_vars(
      'user_granted_indirect',
      array(
        'ID'=>$user_id,
        'NAME'=>$users[$user_id],
        'GROUP'=>$group
        )
      );
  }
}

$user_denied_ids = array_diff(array_keys($users),
                              $user_granted_indirect_ids,
                              $user_granted_direct_ids,
                              $user_refused_indirect_ids,
                              $user_refused_direct_ids);

foreach ($user_denied_ids as $user_id)
{
  $template->assign_block_vars(
    'user_denied',
    array(
      'NAME'=>$users[$user_id],
      'ID'=>$user_id
      )
    );
}


// +-----------------------------------------------------------------------+
// |                           sending html code                           |
// +-----------------------------------------------------------------------+
$template->assign_var_from_handle('ADMIN_CONTENT', 'news_perm');

?>
